unit uTkpMessungen;

{$mode ObjFPC}{$H+}
{$MODESWITCH ADVANCEDRECORDS}

interface

uses
  Classes, SysUtils;

type
  TWellenPos = record
    x,y,z : single;
  end;
 type TTkpMessung = record
  anzahl : integer;
  obereLageAnzahl : integer;
  messung : array of TWellenPos;
  obereLage : array of integer;
  sortedX : array of integer;
  obereLageZ : single;
  sTimeStamp : string;
  procedure extract(sMessung: string);
  procedure setObereLage;
  procedure xSort;
 end;

implementation

procedure TTkpMessung.extract(sMessung: string);
var
  mess : TStringList;
  i, offset: integer;
  sTmp : String;
//  sTimeStamp : string;
  year, month, day, hour, minute, second : word;
begin
  sTmp := StringReplace(sMessung, '+', '', [rfReplaceAll]);
  mess := TStringList.Create;
  mess.CommaText:= sTmp;
  sTimeStamp := '--:--:--';
  if mess.Count = 61 then
     offset := 0
  else if  mess.Count = 64 then
     begin
        offset := 6;
        year := strToInt(mess.Strings[0]);
        month := strToInt(mess.Strings[1]);
        day := strToInt(mess.Strings[2]);
        hour := strToInt(mess.Strings[3]);
        minute := strToInt(mess.Strings[4]);
        second := strToInt(mess.Strings[5]);

        DateTimeToString (sTimeStamp,'tt',encodeTime(hour,minute,second,0));
     end

  else offset := 0;
  // 0 - anzahl
  // 1 x, 2
  sTmp:=mess.Strings[offset];

  DecimalSeparator := '.';
  anzahl := strToInt(sTmp);
  setLength(messung,anzahl);
  for i := 0 to anzahl-1 do
  begin
    messung[i].x := strToFloat(mess.Strings[i*3+1+offset]);
    messung[i].y := strToFloat(mess.Strings[i*3+2+offset]);
    messung[i].z := strToFloat(mess.Strings[i*3+3+offset]);
  end;
  mess.free;
end;
procedure TTkpMessung.setObereLage;
var
  i : integer;
  oben,lagenToleranz : single;

begin
  lagenToleranz := 40.0;
  oben := -500.00;
  obereLageAnzahl :=0;
  setLength(obereLage,obereLageAnzahl);
  for i:=0 to anzahl-1 do
  begin
    // ermittle erkannte welle die am höchsten liegt
    if oben<messung[i].z then oben := messung[i].z;
  end;
  obereLageZ := oben;
  // alle index der wellen die von der obersten lageTol nach unten werden in
  for i:=0 to anzahl-1 do
  begin
    if oben-lagenToleranz <messung[i].z then
    begin
      setLength(obereLage,obereLageAnzahl+1);
      obereLage[obereLageAnzahl] := i;
      obereLageAnzahl := obereLageAnzahl+1;
    end;
  end;
end;
procedure TTkpMessung.xSort;
var
  tmpIndex : array of integer;
  minX : single;
  i,k, lAnzahl, minIndex : integer;
begin

  lAnzahl := length(obereLage);
  setLength(tmpIndex, lAnzahl);
  for i:=0 to lAnzahl-1 do tmpIndex[i] := obereLage[i];

  setLength(sortedX, lAnzahl);

  // sort obere Lage von minX nach maxX
  for k:= 0 to lAnzahl-1 do
  begin
    minX := 1000.0;
    for i:=0 to lAnzahl-1 do
    begin
      if tmpIndex[i]>=0 then
      begin
        if messung[tmpIndex[i]].x < minX then
        begin
          minIndex := tmpIndex[i];
          minX := messung[tmpIndex[i]].x ;
        end;
      end;//if tmpIndex[i]>=0 then
    end; //for i
    sortedX[k] := minIndex;
    tmpIndex[minIndex]:= -1;
  end; // for k

end;

end.

